#include <iostream>
#include <cstring>
using namespace std;

char A[3012] = {2},       			/// Резултатът (първоначално: 2, т.е. 2**1)
		 M[3013];
int len_A=1, 		          			/// Брой цифри в резултата
    len_M,											/// Брой цифри в M
    n,i,j,
    cf,                   			/// Пренос/заем към/от по-старши разряд при аритм. операции
		nf;													/// M е положително (при nf!=0 е отрицателно)

int main () {

	cin >> n >> M;          			/// Входните данни

	/// Степенуването в израза (n-1 пъти умножава резултата с 2)
  while (--n) {									/// n-1 пъти умножаваме резултата с 2.
    for (i=cf=0; i<len_A; i++){ /// Самото умножение на цифрите на резултата:
			A[i] = 2 * A[i] + cf;			/// Умножава поредната цифра с 2 с отчитане на преноса.
			cf = A[i] / 10;						/// Формира пренос към следващата (по-старша) цифра,
			A[i] %= 10;								/// а резултатът в позицията остава едноцифрен.
    }
    if (cf) A[len_A++] = cf;		/// ако след умножението на най-старшата цифра с 2
																/// възниква пренос - разширяваме резултата с една
																/// цифра и в нея записваме преноса
  }

  /// Подготвя M за извъшване на следващите действия в израза
  len_M = strlen(M);						/// Брои знаците (разрядите) в M
	for (i=0, j=len_M-1; i<j ; i++,j--) /// Обръща низа M
		swap(M[i],M[j]);

	nf = M[len_M-1]=='-';					/// Вдига флага nf, ако M е отрицателно,
	if (nf) len_M--;							/// и скъсява М само до цифровите символи

	/// Изважда М от 2**n
	if (nf) { /// Изважда отрицателно число (т.е. събира с |M|)

		for (i=cf=0; i<len_M; i++){
			A[i] += M[i] - '0' + cf;	/// Добавя цифрата на M към съответната цифра на резултата
																/// с отчитане на преноса. Деиствието (M[i] - '0') е необходимо
																/// защото цифрите на М са в "текстов" формат
			cf = A[i] / 10;						/// Формира евентуален пренос към по-старша цифра,
			A[i] %= 10;								/// а резултатът в позицията остава едноцифрен.
		}

		for ( ; cf; i++){						/// Aко е останал пренос след събирането:
			if (i==len_A) len_A++;		/// Разширява резултата с 1 цифра (при необходимост)
			A[i] += cf;								/// и добавя преноса към цифрата на резултата.
			cf = A[i] / 10;						/// Формира пренос към следващата (по-старша) цифра,
			A[i] %= 10;								/// а резултатът в позицията остава едноцифрен.
		}

	}
	else { /// Изважда положително число

		for (i=cf=0; i<len_M; i++){
			A[i] -= M[i] - '0' + cf;	/// Изважда цифрата на M от съответната цифра на резултата
																/// с отчитане на заема извършен от по-младша цифра.
			cf = A[i] < 0; 						/// Формира евентуален заем от по-старша цифра
			if (cf) A[i] += 10;				/// и в този случай преобразува текущата цифра в "положителна"
		}

		for ( ; cf; j++){						/// Aко е останал заем след изваждането,
			A[i] -= cf;								/// изважда го от поредната цифра на резултата,
			cf = A[i] < 0;						/// формира евентуален заем от по-старша цифра и
			if (cf) A[i] += 10;				/// и в този случай преобразува текущата цифра в "положителна"
		}

		while (len_A>1 and A[len_A-1]==0) len_A--;/// маха "водещите" нули след изваждането

	}

  for (i=len_A; i; cout<<(int)A[--i]); cout << endl; /// Извежда резултата

  return 0;
}

